. /tmp/harddisk/accounting/init.sh

ydaylabel=`date -d "$month.$yday-0:00" -u +"%Y%m%d"`
ydaymonth=`date -d "$month.$yday-0:00" -u +"%Y%m"`

# ipnumbers of PC's in LAN
ipnumbers=`cat $accountdir/ipaddress.txt| $AWK '$1 !~ /\?\?\?/ {print $2 }'`

if [ ! -e $datadir ] ; then
	mkdir -p $datadir/history 
fi

if [ "$1" = "init" -o "$1" = "" ]
then
	echo "setting/updating usage counter files"
	i=$(($lowerip-1))
	while [ "$i" -le "$(($upperip+1))" ]
	do
		ip=$ipprefix.$i
		if [ "$i" -eq "$(($lowerip-1))" ]; then
			ip="router"
			bytesout=`iptables -L router_out -vx | $AWK '$7 ~ /'"$WAN"'$/ {print $2 }'`
			bytesin=`iptables -L router_in -vx | $AWK '$8 ~ /'"$WAN"'$/ {print $2 }'`
		else
			if [ "$i" -eq "$(($upperip+1))" ]; then
				ip="other"
			fi
			bytesout=`iptables -L traffic_out -vx | $AWK '$7 ~ /'"$ip"'$/ {print $2 }'`
			bytesin=`iptables -L traffic_in -vx | $AWK '$8 ~ /'"$ip"'$/ {print $2 }'`
		fi
	
		#append new counter values to base dat file
		date -d "$month.$day-$hour:$minute" -u +"%D %H:%M " | sed "s/$/out $bytesout/" | sed "s/$/ in $bytesin/" >>$datadir/$ip.dat
	
		#next increment
		i=$(($i+1))
	done
fi

if [ "$1" = "" ]
then
	rm -f $datadir/all.day.dat
	echo "append usage to day dat files"
	i=$(($lowerip-1))
	while [ "$i" -le "$(($upperip+1))" ]
	do
		ip=$ipprefix.$i
	
		if [ "$i" -eq "$(($lowerip-1))" ]; then
			ip="router"
		else
			if [ "$i" -eq "$(($upperip+1))" ]; then
				ip="other"
			fi
		fi
	
		#calculate deltas and append to day dat file
		$accountdir/usage.sh $accountdir $datadir/$ip.dat >> $datadir/$ip.day.dat
	
		# combine todays totals till now for all ip adresses into 1 file
		label=`cat $accountdir/ipaddress.txt | grep $ip$ | $AWK '{print $1}'`
		if [ "$label" = "" ]; then
			label=$ip
		fi
		dayusage=`$accountdir/daytot.sh $accountdir $datadir/$ip.day.dat`
		echo "$ip $label $dayusage" >> $datadir/all.day.dat

		#next increment
		i=$(($i+1))
	done
fi	
	
if [ $hour = "00" -a $minute = "00" -a "$1" = "" ] || [ "$1" = "daychange" ]
then
	echo "day change: finishing current day dat files and starting a new ones"
	
	rm -f $datadir/all.day.dat
	rm -f $datadir/all.month.dat
	
	i=$(($lowerip-1))
	while [ "$i" -le "$(($upperip+1))" ]
	do
		ip=$ipprefix.$i
	
		if [ "$i" -eq "$(($lowerip-1))" ]; then
			ip="router"
		else
			if [ "$i" -eq "$(($upperip+1))" ]; then
				ip="other"
			fi
		fi
	
		#create history directory
		mkdir -p $datadir/history/$ip
		
		#copy day dat file of last day to history day dat file
		cp $datadir/$ip.day.dat $datadir/history/$ip/$ydaylabel.dat 

		# append totals of last day to month history dat file
		date -d "$month.$yday-0:00" -u +"%D " | sed "s/$/`$accountdir/daytot.sh $accountdir $datadir/$ip.day.dat`/" >> $datadir/history/$ip/$ydaymonth.dat 
		
		#reset day dat file
		rm -f $datadir/$ip.day.dat
		date -d "$month.$day-0:00" -u +"%D %H:%M " | sed "s/$/`echo "out 0 in 0"`/" > $datadir/$ip.day.dat 

		# combine this month totals till now for all ip adresses into 1 file
		label=`cat $accountdir/ipaddress.txt | grep $ip$ | $AWK '{print $1}'`
		if [ "$label" = "" ]; then
			label=$ip
		fi
		echo "$ip $label out 0 in 0" >> $datadir/all.day.dat
		monthusage=`$accountdir/monthtot.sh $accountdir $datadir/history/$ip/$ydaymonth.dat`
		echo "$ip $label $monthusage" >> $datadir/all.month.dat

		#next increment
		i=$(($i+1))
	done
fi

if [ $day = "1" -a "$1" = "" ] || [ "$1" = "monthchange" ]
then
	echo "month change: finishing current month dat files and starting a new ones"
	
	# append totals of last month to overall history dat file
	i=$(($lowerip-1))
	while [ "$i" -le "$(($upperip+1))" ]
	do
		ip=$ipprefix.$i
	
		if [ "$i" -eq "$(($lowerip-1))" ]; then
			ip="router"
		else
			if [ "$i" -eq "$(($upperip+1))" ]; then
				ip="other"
			fi
		fi
	
		# append totals of last day to month file
		date -d "$month.$yday-0:00" -u +"%m/%Y " | sed "s/$/`$accountdir/monthtot.sh $accountdir $datadir/history/$ip/$ydaymonth.dat`/" >> $datadir/$ip.history.dat
		
		mv -f $datadir/history/$ip/$ydaymonth.dat $datadir/history/$ip/$ydaymonth.dat 

		#next increment
		i=$(($i+1))
	done
fi

if [ "$1" = "init" -o "$1" = "" ]
then
	echo "tailing counter files"	
	i=$(($lowerip-1))
	while [ "$i" -le "$(($upperip+1))" ]
	do
		ip=$ipprefix.$i
	
		if [ "$i" -eq "$(($lowerip-1))" ]; then
			ip="router"
		else
			if [ "$i" -eq "$(($upperip+1))" ]; then
				ip="other"
			fi
		fi
	
		#remove oldest counter values form base dat file
		tail -1 $datadir/$ip.dat > $datadir/$ip.tmp.dat
		mv $datadir/$ip.tmp.dat $datadir/$ip.dat
		
		#next increment
		i=$(($i+1))
	done
fi

echo "finished."
	
	
	
	
