. /tmp/harddisk/accounting/init.sh
# ipnumbers of PC's in LAN
ipnumbers=`cat $accountdir/ipaddress.txt| $AWK '{print $2 }'`

# create two chains for in and outbound traffic of ROUTER (HTTP/FTP etc)
iptables -N router_out
iptables -N router_in
# add rules for both directions
iptables -A router_out
iptables -A router_in
# attach chains to INPUT/OUTPUT
iptables -I INPUT -j router_in -d $WAN -s ! $ipprefix.0/24
iptables -I OUTPUT -j router_out -s $WAN -d ! $ipprefix.0/24

# create two chains for in and outbound traffic of LAN
iptables -N traffic_out
iptables -N traffic_in

# add rules for both directions for each IP address 
i=$lowerip
while [ $i -le $upperip ]
do
	ip=$ipprefix.$i
	iptables -A traffic_in -i eth1 -d $ip
	iptables -A traffic_out -o eth1 -s $ip

	#next increment
	i=$(($i+1))
done

#append general rules to track all traffic from unknown LAN addresses
iptables -A traffic_in -i eth1 -d ! $LAN/$LANMask
iptables -A traffic_out -o eth1 -s ! $LAN/$LANMask

# attach chains to FORWARD
iptables -I FORWARD -j traffic_in
iptables -I FORWARD -j traffic_out
