BEGIN {
psFontSize="9pt";
psTitleFontSize="12pt";
piBarSize="10";
psBarUnit="px";
psAxisLabel="MBytes";
piMaxSize=800;
piLableWidth = 150;
psMaxSizeUnit="px";
paColors[0]="#5555aa";
paColors[1]="#7777dd";
iColors=2;

nRow=0;
totout=0;
totin=0;

ipaddr = ip;
titlesuffix = suffix;
if (titlesuffix == "") titlesuffix = "Current Month";
}

{ 
datetime[nRow]=$1;
split($1,dateparts,"/");
year[nRow]= "20" dateparts[3];
month[nRow]= dateparts[1];
day[nRow]= dateparts[2];
bytes[2,nRow]=int(10*$3/(1024*1024))/10;
totout += bytes[2,nRow];
bytes[1,nRow]=int(10*$5/(1024*1024))/10;
totin += bytes[1,nRow];nRow++;
}

END {

	iMax = 0;
	for(iRow = 0; iRow<nRow; iRow++) {
		if (bytes[1,iRow] > iMax) iMax = bytes[1,iRow];
		if (bytes[2,iRow] > iMax) iMax = bytes[2,iRow];
	} 
	
	sHTML = ""
	
	for (i=1; i<3; i++)
	{
		if (i==1)
		{
			total = totin;
			title = "Downstream Traffic Load (in " psAxisLabel ") - " titlesuffix;
		}
		else
		{
			total = totout;
			title = "Upstream Traffic Load (in " psAxisLabel ") - " titlesuffix;
		}
		
		sHTML = sHTML "<table style='font-family: Arial; font-size: " psFontSize "'>";
		sHTML = sHTML "<tr><td colspan=2 align='center' style='font-family: Arial; font-size: " psTitleFontSize "'><u><b>" title "</b></u></td></tr>";
		sHTML = sHTML "<tr><td align='right' style='width: " piLableWidth psMaxSizeUnit ";'>";
		for(iRow = 0; iRow<nRow; iRow++) {
			sHTML = sHTML "<div style ='height: " piBarSize psBarUnit ";'>" datetime[iRow] "</div>";
			
		} 
		
		iScale = iMax / piMaxSize;
		sHTML = sHTML "</td><td> \
				<TABLE style='border-bottom: 1px solid black; border-left: 1px solid black;font-family: Arial; font-size: " psFontSize "; '> \
						<tr><td style='width: " piMaxSize psMaxSizeUnit ";'> \
				";
		for(iRow = 0; iRow < nRow; iRow++) {
			sColor = paColors[iRow % iColors];
			if (iScale == 0) iScale=1;
			iBarLength = int(bytes[i,iRow] / iScale);
			sHTML = sHTML "	<div style='background-color: " sColor "; text-align: right; color: white; \
									 height: " piBarSize psBarUnit ";  \
									 width: " iBarLength psMaxSizeUnit "; \
									 cursor: hand;' \
									 onClick='document.location.href=\"traffic.cgi?ipaddr=" ipaddr "&year=" year[iRow] "&month=" month[iRow] "&day=" day[iRow] "\"'> \
									 " bytes[i,iRow] "&nbsp;</div> ";
		}
		
		sHTML = sHTML "			</td></tr>	\
				</table></td></tr> \
				<tr><td></td><td>" psAxisLabel " (Total = " total " " psAxisLabel ")</td></tr>\
				</table> \
				<br>";
	}
	print sHTML;
}
