#!/bin/sh
# cgi script to generate graphs of selected pc
# selection of cgi-bin GET method is put in QUERY_STRING
#
. /mnt/usbfs/accounting/init.sh
todaysmonth=`date -d "$month.$day-0:00" -u +"%Y%m"`

reqip=`echo $QUERY_STRING| sed -e "s/ipaddr=//" -e "s/&.*$//" -e "s/&$//"`
reqyear=`echo $QUERY_STRING| sed -e "s/ipaddr=$reqip//" -e "s/^&year=//" -e "s/&.*$//" -e "s/&$//"`
reqmonth=`echo $QUERY_STRING| sed -e "s/ipaddr=$reqip//" -e "s/&year=$reqyear//" -e "s/^&month=//" -e "s/&.*$//" -e "s/&$//"`
reqday=`echo $QUERY_STRING| sed -e "s/ipaddr=$reqip//" -e "s/&year=$reqyear//" -e "s/&month=$reqmonth//" -e "s/^&day=//" -e "s/&.*$//" -e "s/&$//"`
echo "Content-type: text/html"
echo ""
echo "<html>"
echo "<head>"
echo "<META HTTP-EQUIV='CACHE-CONTROL' CONTENT='NO-CACHE'>"
echo "<META HTTP-EQUIV='EXPIRES' CONTENT='0'>"
echo "<META HTTP-EQUIV='PRAGMA' CONTENT='NO-CACHE'>"
echo "<title>WL500g Usage statistics</title>"
echo "</head>"
echo "<body bgcolor='#aaaaee' style='font-family: Arial; '>"
indexlink="<a style='font-family: Arial; font-size: 12; color: black' href='traffic.cgi'>Back to index</a>"
copyright="<span style='font-family: Arial; font-size: 12; color: black'>IP accounting application (c) 2004 by Mark Koops & SOdB</span>";
header="<table width='100%'><tr><td align='left'>$indexlink</td><td align='right'>$copyright</td></tr></table>"
if [ "$reqip" = "" ]
then
	echo "$header <h1 align='center' style='font-family: Arial;'>Statistics Overview</h1><br>"
	if [ -e $datadir/all.day.dat ] ; then
		cat $datadir/all.day.dat | $AWK -f $accountdir/graph_all.awk -v type=day 
	fi
	if [ -e $datadir/all.month.dat ] ; then
		cat $datadir/all.month.dat | $AWK -f $accountdir/graph_all.awk -v type=month 
	fi
else
	label=`cat $accountdir/ipaddress.txt | grep $reqip$ | $AWK '{print $1}'`
	if [ "$label" != "" ] ;	then
		label=`echo "$label" | $AWK '{print " (" $1 ")"}'`
	fi 
	echo "$header <h1 align='center' style='font-family: Arial;'>Statistics For Host $reqip $label</h1><br>"

	if [ "$reqmonth" = "" ] ;	then
		if [ -e $datadir/$reqip.day.dat ] ; then
			cat $datadir/$reqip.day.dat | $AWK -f $accountdir/graph_day.awk -v ip=$reqip
		fi
		
		if [ -e $datadir/history/$reqip/$todaysmonth.dat ] ; then
			cat $datadir/history/$reqip/$todaysmonth.dat | $AWK -f $accountdir/graph_month.awk -v ip=$reqip
		fi
		
		if [ -e $datadir/$ip.history.dat ] ; then
			cat $datadir/$ip.history.dat | $AWK -f $accountdir/graph_month.awk -v ip=$reqip -v suffix=History
		else
			echo "<h3 align='center' style='font-family: Arial;'>No history data available for host '$reqip'.</h3>"
		fi
	else

		if [ "$reqday" != "" ] ; then
			if [ -e $datadir/history/$reqip/$reqyear$reqmonth$reqday.dat ] ; then
				cat $datadir/history/$reqip/$reqyear$reqmonth$reqday.dat | $AWK -f $accountdir/graph_day.awk -v ip=$reqip  -v suffix=$reqmonth/$reqday/$reqyear
			else
				echo "<h3 align='center' style='font-family: Arial;'>No data available for host '$reqip' and day '$reqmonth/$reqday/$reqyear'.</h3>"
			fi
		fi
		
		if [ -e $datadir/history/$reqip/$reqyear$reqmonth.dat ] ; then
			cat $datadir/history/$reqip/$reqyear$reqmonth.dat | $AWK -f $accountdir/graph_month.awk -v ip=$reqip -v suffix=$reqmonth/$reqyear
		else
			echo "<h3 align='center' style='font-family: Arial;'>No data available for host '$reqip' and month '$reqmonth/$reqyear'.</h3>"
		fi

	fi
fi
echo "</html>"

